# Annotation Glossary

### A

array

  Parameter points to an array of items.

### C

constructor

  This symbol is a constructor, not a static method.

### N

not nullable

  NULL must not be passed as the value in, out, in-out; or as a return value.

nullable

  NULL may be passed as the value in, out, in-out; or as a return value.

### O

optional

  NULL may be passed instead of a pointer to a location.

out

  Parameter for returning results. Default is transfer full.

out caller-allocates

  Out parameter, where caller must allocate storage.

### T

transfer full

  The caller owns the data, and is responsible for free it.

transfer none

  The data is owned by the callee, which is responsible of freeing it.